Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkRectilinearGrid Class Reference

`#include <vtkRectilinearGrid.h>`

Inheritance diagram for vtkRectilinearGrid:

[legend]
Collaboration diagram for vtkRectilinearGrid:

[legend]
List of all members.

## Detailed Description

a datset that is topologically regular with variable spacing in the three coordinate directions

Date:
  2002/11/12 19:21:02

Revision:
  1.59

vtkRectilinearGrid is a data object that is a concrete implementation of vtkDataSet. vtkRectilinearGrid represents a geometric structure that is topologically regular with variable spacing in the three coordinate directions x-y-z.

To define a vtkRectilinearGrid, you must specify the dimensions of the data and provide three arrays of values specifying the coordinates along the x-y-z axes. The coordinate arrays are specified using three vtkDataArray objects (one for x, one for y, one for z).

Warning:
  Make sure that the dimensions of the grid match the number of coordinates in the x-y-z directions. If not, unpredictable results (including program failure) may result. Also, you must supply coordinates in all three directions, even if the dataset topology is 2D, 1D, or 0D.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Law, Charles (39%)
  - Schroeder, Will (32%)
  - Geveci, Berk (5%)
  - Miller, Jim (5%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkRectilinearGrid.h)`
  - .`cxx` (`/Common/vtkRectilinearGrid.cxx)`

Examples:
  vtkRectilinearGrid (Examples)

Tests:
  vtkRectilinearGrid (Tests)

Definition at line 70 of file vtkRectilinearGrid.h.

## Public Types
typedef vtkDataSet | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
int | GetDataObjectType ()
void | CopyStructure (vtkDataSet *ds)
void | Initialize ()
int | GetDataDimension ()
int | ComputeStructuredCoordinates (float x[3], int ijk[3], float pcoords[3])
vtkIdType | ComputePointId (int ijk[3])
vtkIdType | ComputeCellId (int ijk[3])
unsigned long | GetActualMemorySize ()
virtual void | UpdateData ()
vtkIdType | GetNumberOfCells ()
vtkIdType | GetNumberOfPoints ()
float * | GetPoint (vtkIdType ptId)
void | GetPoint (vtkIdType id, float x[3])
vtkCell * | GetCell (vtkIdType cellId)
void | GetCell (vtkIdType cellId, vtkGenericCell *cell)
void | GetCellBounds (vtkIdType cellId, float bounds[6])
int | FindPoint (float x, float y, float z)
vtkIdType | FindPoint (float x[3])
vtkIdType | FindCell (float x[3], vtkCell *cell, vtkIdType cellId, float tol2, int &subId, float pcoords[3], float *weights)
vtkIdType | FindCell (float x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, float tol2, int &subId, float pcoords[3], float *weights)
vtkCell * | FindAndGetCell (float x[3], vtkCell *cell, vtkIdType cellId, float tol2, int &subId, float pcoords[3], float *weights)
int | GetCellType (vtkIdType cellId)
void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)
void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds)
void | ComputeBounds ()
int | GetMaxCellSize ()
void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds)
void | SetDimensions (int i, int j, int k)
void | SetDimensions (int dim[3])
virtual int * | GetDimensions ()
virtual void | GetDimensions (int data[3])
virtual void | SetXCoordinates (vtkDataArray *)
virtual vtkDataArray * | GetXCoordinates ()
virtual void | SetYCoordinates (vtkDataArray *)
virtual vtkDataArray * | GetYCoordinates ()
virtual void | SetZCoordinates (vtkDataArray *)
virtual vtkDataArray * | GetZCoordinates ()
void | SetUpdateExtent (int piece, int numPieces, int ghostLevel)
void | SetUpdateExtent (int piece, int numPieces)
void | SetUpdateExtent (int x1, int x2, int y1, int y2, int z1, int z2)
void | SetUpdateExtent (int ext[6])
void | SetExtent (int extent[6])
void | SetExtent (int x1, int x2, int y1, int y2, int z1, int z2)
virtual int * | GetExtent ()
virtual void | GetExtent (int &, int &, int &, int &, int &, int &)
virtual void | GetExtent (int[6])
void | ShallowCopy (vtkDataObject *src)
void | DeepCopy (vtkDataObject *src)
## Static Public Methods
vtkRectilinearGrid * | New ()
int | IsTypeOf (const char *type)
vtkRectilinearGrid * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkRectilinearGrid ()
| ~vtkRectilinearGrid ()
int | GetExtentType ()
virtual void | Crop ()
## Protected Attributes
vtkVertex * | Vertex
vtkLine * | Line
vtkPixel * | Pixel
vtkVoxel * | Voxel
int | Dimensions [3]
int | DataDescription
vtkDataArray * | XCoordinates
vtkDataArray * | YCoordinates
vtkDataArray * | ZCoordinates
float | PointReturn [3]

## Member Typedef Documentation

typedef vtkDataSet vtkRectilinearGrid::Superclass

| Reimplemented from vtkDataSet. Definition at line 75 of file vtkRectilinearGrid.h.

## Constructor & Destructor Documentation

vtkRectilinearGrid::vtkRectilinearGrid | ( |  | ) | `[protected]`

vtkRectilinearGrid::~vtkRectilinearGrid | ( |  | ) | `[protected]`

## Member Function Documentation

vtkRectilinearGrid* vtkRectilinearGrid::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkDataObject.

virtual const char* vtkRectilinearGrid::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataSet.

int vtkRectilinearGrid::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSet.

virtual int vtkRectilinearGrid::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSet.

vtkRectilinearGrid* vtkRectilinearGrid::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataSet.

void vtkRectilinearGrid::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataSet.

int vtkRectilinearGrid::GetDataObjectType | ( |  | ) | `[inline, virtual]`

| Return what type of dataset this is. Reimplemented from vtkDataSet. Definition at line 79 of file vtkRectilinearGrid.h. References VTK_RECTILINEAR_GRID.

void vtkRectilinearGrid::CopyStructure | ( | vtkDataSet * | ds | ) | `[virtual]`

| Copy the geometric and topological structure of an input rectilinear grid object. Implements vtkDataSet.

void vtkRectilinearGrid::Initialize | ( |  | ) | `[virtual]`

| Restore object to initial state. Release memory back to system. Reimplemented from vtkDataSet.

vtkIdType vtkRectilinearGrid::GetNumberOfCells | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 255 of file vtkRectilinearGrid.h. References Dimensions, and vtkIdType.

vtkIdType vtkRectilinearGrid::GetNumberOfPoints | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 275 of file vtkRectilinearGrid.h. References Dimensions, and vtkIdType.

float* vtkRectilinearGrid::GetPoint | ( | vtkIdType | ptId | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkRectilinearGrid::GetPoint | ( | vtkIdType | id,
|  | float | x[3]
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

vtkCell* vtkRectilinearGrid::GetCell | ( | vtkIdType | cellId | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkRectilinearGrid::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkRectilinearGrid::GetCellBounds | ( | vtkIdType | cellId,
|  | float | bounds[6]
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

int vtkRectilinearGrid::FindPoint | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet. Definition at line 97 of file vtkRectilinearGrid.h. References vtkDataSet::FindPoint().

vtkIdType vtkRectilinearGrid::FindPoint | ( | float | x[3] | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

vtkIdType vtkRectilinearGrid::FindCell | ( | float | x[3],
|  | vtkCell * | cell,
|  | vtkIdType | cellId,
|  | float | tol2,
|  | int & | subId,
|  | float | pcoords[3],
|  | float * | weights
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

vtkIdType vtkRectilinearGrid::FindCell | ( | float | x[3],
|  | vtkCell * | cell,
|  | vtkGenericCell * | gencell,
|  | vtkIdType | cellId,
|  | float | tol2,
|  | int & | subId,
|  | float | pcoords[3],
|  | float * | weights
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

vtkCell* vtkRectilinearGrid::FindAndGetCell | ( | float | x[3],
|  | vtkCell * | cell,
|  | vtkIdType | cellId,
|  | float | tol2,
|  | int & | subId,
|  | float | pcoords[3],
|  | float * | weights
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

int vtkRectilinearGrid::GetCellType | ( | vtkIdType | cellId | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet.

void vtkRectilinearGrid::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 108 of file vtkRectilinearGrid.h. References vtkStructuredData::GetCellPoints(), and vtkIdType.

void vtkRectilinearGrid::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 111 of file vtkRectilinearGrid.h. References vtkStructuredData::GetPointCells(), and vtkIdType.

void vtkRectilinearGrid::ComputeBounds | ( |  | ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

int vtkRectilinearGrid::GetMaxCellSize | ( |  | ) | `[inline, virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Implements vtkDataSet. Definition at line 114 of file vtkRectilinearGrid.h.

void vtkRectilinearGrid::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds
| ) | `[virtual]`

| Standard vtkDataSet API methods. See vtkDataSet for more information. Reimplemented from vtkDataSet.

void vtkRectilinearGrid::SetDimensions | ( | int | i,
|  | int | j,
|  | int | k
| ) |

| Set dimensions of rectilinear grid dataset. This also sets the extent.

void vtkRectilinearGrid::SetDimensions | ( | int | dim[3] | ) |

| Set dimensions of rectilinear grid dataset. This also sets the extent.

virtual int* vtkRectilinearGrid::GetDimensions | ( |  | ) | `[virtual]`

| Get dimensions of this rectilinear grid dataset.

virtual void vtkRectilinearGrid::GetDimensions | ( | int | data[3] | ) | `[virtual]`

| Get dimensions of this rectilinear grid dataset.

int vtkRectilinearGrid::GetDataDimension | ( |  | ) | `[inline]`

| Return the dimensionality of the data. Definition at line 280 of file vtkRectilinearGrid.h. References vtkStructuredData::GetDataDimension().

int vtkRectilinearGrid::ComputeStructuredCoordinates | ( | float | x[3],
|  | int | ijk[3],
|  | float | pcoords[3]
| ) |

| Convenience function computes the structured coordinates for a point x[3]. The cell is specified by the array ijk[3], and the parametric coordinates in the cell are specified with pcoords[3]. The function returns a 0 if the point x is outside of the grid, and a 1 if inside the grid.

vtkIdType vtkRectilinearGrid::ComputePointId | ( | int | ijk[3] | ) | `[inline]`

| Given a location in structured coordinates (i-j-k), return the point id. Definition at line 285 of file vtkRectilinearGrid.h. References vtkStructuredData::ComputePointId(), and vtkIdType.

vtkIdType vtkRectilinearGrid::ComputeCellId | ( | int | ijk[3] | ) | `[inline]`

| Given a location in structured coordinates (i-j-k), return the cell id. Definition at line 290 of file vtkRectilinearGrid.h. References vtkStructuredData::ComputeCellId(), and vtkIdType.

virtual void vtkRectilinearGrid::SetXCoordinates | ( | vtkDataArray * |  | ) | `[virtual]`

| Specify the grid coordinates in the x-direction.

virtual vtkDataArray* vtkRectilinearGrid::GetXCoordinates | ( |  | ) | `[virtual]`

| Specify the grid coordinates in the x-direction.

virtual void vtkRectilinearGrid::SetYCoordinates | ( | vtkDataArray * |  | ) | `[virtual]`

| Specify the grid coordinates in the y-direction.

virtual vtkDataArray* vtkRectilinearGrid::GetYCoordinates | ( |  | ) | `[virtual]`

| Specify the grid coordinates in the y-direction.

virtual void vtkRectilinearGrid::SetZCoordinates | ( | vtkDataArray * |  | ) | `[virtual]`

| Specify the grid coordinates in the z-direction.

virtual vtkDataArray* vtkRectilinearGrid::GetZCoordinates | ( |  | ) | `[virtual]`

| Specify the grid coordinates in the z-direction.

void vtkRectilinearGrid::SetUpdateExtent | ( | int | piece,
|  | int | numPieces,
|  | int | ghostLevel
| ) |

| Required for the lowest common denominator for setting the UpdateExtent (i.e. vtkDataSetToStructuredPointsFilter). This assumes that WholeExtent is valid (UpdateInformation has been called).

void vtkRectilinearGrid::SetUpdateExtent | ( | int | piece,
|  | int | numPieces
| ) | `[inline]`

| Required for the lowest common denominator for setting the UpdateExtent (i.e. vtkDataSetToStructuredPointsFilter). This assumes that WholeExtent is valid (UpdateInformation has been called). Reimplemented from vtkDataObject. Definition at line 172 of file vtkRectilinearGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkRectilinearGrid::SetUpdateExtent | ( | int | x1,
|  | int | x2,
|  | int | y1,
|  | int | y2,
|  | int | z1,
|  | int | z2
| ) | `[inline, virtual]`

| Call superclasses method to avoid hiding Reimplemented from vtkDataObject. Definition at line 178 of file vtkRectilinearGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkRectilinearGrid::SetUpdateExtent | ( | int | ext[6] | ) | `[inline, virtual]`

| Call superclasses method to avoid hiding Reimplemented from vtkDataObject. Definition at line 180 of file vtkRectilinearGrid.h. References vtkDataObject::SetUpdateExtent().

void vtkRectilinearGrid::SetExtent | ( | int | extent[6] | ) |

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

void vtkRectilinearGrid::SetExtent | ( | int | x1,
|  | int | x2,
|  | int | y1,
|  | int | y2,
|  | int | z1,
|  | int | z2
| ) |

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual int* vtkRectilinearGrid::GetExtent | ( |  | ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual void vtkRectilinearGrid::GetExtent | ( | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & |
| ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

virtual void vtkRectilinearGrid::GetExtent | ( | int | [6] | ) | `[virtual]`

| Different ways to set the extent of the data array. The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

unsigned long vtkRectilinearGrid::GetActualMemorySize | ( |  | ) | `[virtual]`

| Return the actual size of the data in kilobytes. This number is valid only after the pipeline has updated. The memory size returned is guaranteed to be greater than or equal to the memory required to represent the data (e.g., extra space in arrays, etc. are not included in the return value). THIS METHOD IS THREAD SAFE. Reimplemented from vtkDataSet.

void vtkRectilinearGrid::ShallowCopy | ( | vtkDataObject * | src | ) | `[virtual]`

| Shallow and Deep copy. Reimplemented from vtkDataSet.

void vtkRectilinearGrid::DeepCopy | ( | vtkDataObject * | src | ) | `[virtual]`

| Shallow and Deep copy. Reimplemented from vtkDataSet.

virtual void vtkRectilinearGrid::UpdateData | ( |  | ) | `[virtual]`

| WARNING: INTERNAL METHOD - NOT FOR GENERAL USE. THIS METHOD IS PART OF THE PIPELINE UPDATE FUNCTIONALITY. Propagate the update back up the pipeline, and perform the actual work of updating on the way down. This subclass version of the method adds ghost level arrays if a request is made as pieces. Reimplemented from vtkDataObject.

int vtkRectilinearGrid::GetExtentType | ( |  | ) | `[inline, protected, virtual]`

| Reimplemented from vtkDataObject. Definition at line 224 of file vtkRectilinearGrid.h. References VTK_3D_EXTENT.

virtual void vtkRectilinearGrid::Crop | ( |  | ) | `[protected, virtual]`

| Reallocates and copies to set the Extent to the UpdateExtent. This is used internally when the exact extent is requested, and the source generated more than the update extent. Reimplemented from vtkDataObject.

## Member Data Documentation

vtkVertex* vtkRectilinearGrid::Vertex`[protected]`

| Definition at line 218 of file vtkRectilinearGrid.h.

vtkLine* vtkRectilinearGrid::Line`[protected]`

| Definition at line 219 of file vtkRectilinearGrid.h.

vtkPixel* vtkRectilinearGrid::Pixel`[protected]`

| Definition at line 220 of file vtkRectilinearGrid.h.

vtkVoxel* vtkRectilinearGrid::Voxel`[protected]`

| Definition at line 221 of file vtkRectilinearGrid.h.

int vtkRectilinearGrid::Dimensions[3]`[protected]`

| Definition at line 231 of file vtkRectilinearGrid.h. Referenced by GetNumberOfCells(), and GetNumberOfPoints().

int vtkRectilinearGrid::DataDescription`[protected]`

| Definition at line 232 of file vtkRectilinearGrid.h.

vtkDataArray* vtkRectilinearGrid::XCoordinates`[protected]`

| Definition at line 234 of file vtkRectilinearGrid.h.

vtkDataArray* vtkRectilinearGrid::YCoordinates`[protected]`

| Definition at line 235 of file vtkRectilinearGrid.h.

vtkDataArray* vtkRectilinearGrid::ZCoordinates`[protected]`

| Definition at line 236 of file vtkRectilinearGrid.h.

float vtkRectilinearGrid::PointReturn[3]`[protected]`

| Definition at line 239 of file vtkRectilinearGrid.h.

The documentation for this class was generated from the following file:

- Common/vtkRectilinearGrid.h